@echo off
::
:: Unpack Boot/Recovery image.
::    %1 - Recovery or Boot directory
::    %2 - recovery or boot file
:: 

cls
echo.
echo *********************************
echo *      Unpack %2.img       
echo *********************************
echo.

if not exist Unpack/Firmware/Image/%2.img echo. & echo ***  %2.img not found!  *** & echo. & goto exit

call App/_mkdir.bat Unpack %1
xcopy Unpack\Firmware\Image\%2.img Unpack\%1\*.img > NUL
cd Unpack\%1

dd if=%2.img of=sign.txt bs=4 count=1 > NUL 2>&1
for /f %%a in ('cat sign.txt') do set sign=%%a
del sign.txt
if "%sign%"=="KRNL" goto k
if "%sign%"=="ANDR" goto a
        
:k
:: ------ magic=KRNL -------
mkkrnlimg -r %2.img %2.cpio.gz
gzip -t -q %2.cpio.gz 
if errorlevel 1 goto mov
if errorlevel 0 gzip -d %2.cpio.gz & goto cpi
:mov
move %2.cpio.gz %2.cpio > NUL
:cpi
cpio -i < %2.cpio & del *.cpio & del *.img & cd .. & cd ..
set err_file=Unpack/%1/init.rc
goto exit

:a
:: ------ magic=ANDROID -------
if not exist cfg mkdir cfg
if not exist kernel mkdir kernel
if not exist ramdisk mkdir ramdisk

abootimg -i %2.img > %2.info
abootimg -x %2.img cfg/%2.cfg kernel/zImage ramdisk/initrd.cpio.gz & del *.img
     
cd ramdisk/

setlocal enabledelayedexpansion
for /f %%a in ('dd if^=initrd.cpio.gz bs^=2 count^=1') do set arc=%%a
if "%arc%"=="" gzip -d initrd.cpio.gz & goto cpi1
if "%arc%"=="L" lzop -d initrd.cpio.gz -o initrd.cpio & goto cpi1
endlocal

:mov1
move initrd.cpio.gz initrd.cpio > NUL
:cpi1
cpio -i < initrd.cpio & del *.cpio & cd .. & cd .. & cd ..
set err_file=Unpack/%1/ramdisk/init.rc

:exit
call App/_ok_err.bat %err_file%
